/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _COMBINED_LS_H 

#define _COMBINED_LS_H 1

#include <realea/common/ilocalsearch.h>

namespace realea {

/**
 * @class
 *
 * This class allow us to apply a local search different to each individual
 */
class CombinedLS : public ILocalSearch {
   private:

    /**
     * Init all the Local Search into the pool with the information required.
     *
     */
    void setLSPool(void); 

   public:
       CombinedLS(void);
       ~CombinedLS(void);
       /**
	* Add a new Local Search to the model
	*
	* @param ls new LS method
	*/
       void addLocalSearch(ILocalSearch *ls);

    public:
	unsigned apply(ILSParameters *opt, tChromosomeReal &sol, tFitness &fitness, unsigned itera);
	ILSParameters *getInitOptions(tChromosomeReal &sol);

    private:
       vector<ILocalSearch*> m_pool;
       bool m_initpool;
};

};

#endif
