/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LSCROSS_H

#define _LSCROSS_H 1

#include <realea/common/ilocalsearch.h>

namespace realea {

/**
 * This class improve the solution with the repeated use of a LS method
 */
class LSCross : public ILocalSearch {
   public:
       LSCross(double alpha);
    
    protected:
        unsigned apply(ILSParameters *opt, tChromosomeReal &sol, tFitness &fitness, unsigned itera);
	ILSParameters *getInitOptions(tChromosomeReal &sol);
    private:
	unsigned applyNeigh(tChromosomeReal &sol, PopulationReal *pop, tFitness &fitness, unsigned maxeval); 
	double m_alpha;
};

}

#endif
